# Generated by Django 5.1.6 on 2025-03-01 04:49

from django.db import migrations
from django.db import models

import documents.models


def convert_assign_custom_fields(apps, schema_editor):
    # Convert the old assign_custom_fields ManyToManyField to the new assign_custom_fields_w_values JSONField
    WorkflowAction = apps.get_model("documents", "WorkflowAction")
    for workflow_action in WorkflowAction.objects.all():
        if workflow_action.assign_custom_fields.exists():
            workflow_action.assign_custom_fields_w_values = {
                custom_field.id: None
                for custom_field in workflow_action.assign_custom_fields.all()
            }
            workflow_action.save()


class Migration(migrations.Migration):
    dependencies = [
        ("documents", "1063_paperlesstask_type_alter_paperlesstask_task_name_and_more"),
    ]

    operations = [
        migrations.AddField(
            model_name="workflowaction",
            name="assign_custom_fields_w_values",
            field=models.JSONField(
                blank=True,
                help_text="assign these custom fields, with optional values",
                null=True,
                verbose_name=documents.models.CustomField,
            ),
        ),
        migrations.RunPython(convert_assign_custom_fields, migrations.RunPython.noop),
        migrations.RemoveField(
            model_name="workflowaction",
            name="assign_custom_fields",
        ),
    ]
